//+------------------------------------------------------------------+
//|                                                    New Robot.mq4 |
//|                            Copyright  2006, Archer Trading, LLC |
//|                                     http://www.archertrading.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Archer Trading, LLC"
#property link      "http://www.archertrading.net"

//+------------------------------------------------------------------+
//|              External Variables                                  |
//+------------------------------------------------------------------+

extern double PercentRisk = 0.10;
extern int Slippage = 5;
extern int PairsTraded = 1;
extern int MarginPerLot = 1000;
extern int DecimalPlaces = 4;
extern int SMAShortPeriod = 10;
extern int ATRPeriod = 10;
extern double ATRStopMultiple = 3.0;

//+------------------------------------------------------------------+
//|              Internal Variables                                  |
//+------------------------------------------------------------------+

int BarCount;
int Current;
bool TickCheck = False;
bool EachTickMode = False;

//+------------------------------------------------------------------+
//|              Expert Initialization                               |
//+------------------------------------------------------------------+

int init() {
   BarCount = Bars;

   if (EachTickMode) Current = 0; else Current = 1;

   return(0);
}

//+------------------------------------------------------------------+
//|              Expert Deinitialization                             |
//+------------------------------------------------------------------+

int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
//|                   Expert start                                   |
//+------------------------------------------------------------------+
int start()
  {
if (EachTickMode && Bars != BarCount) EachTickMode = True;

//+------------------------------------------------------------------+
//|                 Set variables and indicators                     |   
//+------------------------------------------------------------------+ 

double cnt=0, OpenTrades=0, total=0;
// SMA
double SMAShort = iMA(NULL, NULL, SMAShortPeriod, 0, MODE_SMA, PRICE_CLOSE, 0);
// ATR
double ATR = iATR(NULL, NULL, ATRPeriod, 0);

//+------------------------------------------------------------------+
//|                      Calculate Stops                             |   
//+------------------------------------------------------------------+  

double StopLossCalc = ATR * ATRStopMultiple;
double StopLoss = NormalizeDouble (StopLossCalc, DecimalPlaces);
int MinStop = MarketInfo(Symbol(),MODE_STOPLEVEL);
   if (Ask-StopLoss>Ask-MinStop*Point)
      {  
      StopLoss=(MinStop+1)*Point;
      }

//+------------------------------------------------------------------+
//|                      Money Managment                             |   
//+------------------------------------------------------------------+   

double Balance, Lots;  
Balance = AccountBalance();
Lots = MathRound((Balance * PercentRisk) / MarginPerLot / PairsTraded);

if (Lots > 100)
   {
   Lots = 100;
   }
if (Lots < 1)
   {
   Lots = 1;
   }

//+------------------------------------------------------------------+
//|                      Trade Function                              |   
//+------------------------------------------------------------------+   

OpenTrades=0;

total=OrdersTotal();
for(cnt=0;cnt<total;cnt++)
{ 
OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if ( OrderSymbol()==Symbol() ) OpenTrades = OpenTrades+1;  
}
   if (OpenTrades == 0)
   {
   if (Close[1] > SMAShort)//Long
      {
      OrderSend(Symbol(),OP_BUY, Lots, Ask, Slippage, Ask-StopLoss, 0, NULL, 0, 0, Blue);
      OpenTrades ++;
      if(OpenTrades > 0)
           {
            if(OrderSelect(cnt,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError());          
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0); 
        }
   if (Close[1] < SMAShort)//Short
      {
      OrderSend(Symbol(),OP_SELL, Lots, Bid, Slippage, Bid+StopLoss, 0, NULL, 0, 0, Red);
      OpenTrades ++;
      if(OpenTrades > 0)
           {
            if(OrderSelect(cnt,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         if (EachTickMode) TickCheck = True;
         if (!EachTickMode) BarCount = Bars;
         return(0); 
        }
      
   }

total=OrdersTotal();
for(cnt=0;cnt<total;cnt++)
{

//+------------------------------------------------------------------+
//|         Check to see if orders should be closed                  |
//+------------------------------------------------------------------+

OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if ((OrderType()== OP_BUY) && (OrderSymbol()== Symbol())) 
         {
         if (Close[1] < SMAShort)   
            { 
            OrderClose(OrderTicket(), Lots, Bid, Slippage, Yellow);
            if (EachTickMode) TickCheck = True;
            if (!EachTickMode) BarCount = Bars;
            return(0);
            }
         }
OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if ((OrderType()== OP_SELL) && (OrderSymbol()== Symbol()))          
         {
         if (Close[1] > SMAShort) 
            {
            OrderClose(OrderTicket(), Lots, Ask, Slippage, Yellow);
            if (EachTickMode) TickCheck = True;
            if (!EachTickMode) BarCount = Bars;
            return(0);
            }
         }    
 
}
if (!EachTickMode) BarCount = Bars;
   return(0);
  }
//+------------------------------END---------------------------------+